<!DOCTYPE html>
<html>
<head>
    <base href="${r'${contextPath}'}"/>
    <meta charset="utf-8">
    <title>${r'${formName}'}</title>
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
    <link rel="stylesheet" type="text/css" href="static/form/css/form-app.css?v=1">
    <link rel="stylesheet" type="text/css" href="static/form/css/oa-user-select.css?v=1">
    <link rel="stylesheet" type="text/css" href="static/form/css/oa-form.css?v=1">
</head>
<body>
<div class="layui-anim layui-anim-fadein">
    <div class="layui-card">
        <div class="layui-card-body" style="padding: 15px;">
            <form class="layui-form layui-form-pane" lay-filter="dataForm">
                <div class="layui-row oa-form-footer-tool-bar">
                    <div class="layui-col-xs5 tool-bar-left layui-layout-admin">
                        <div id="submitBtnGroup" class="layui-btn-group"></div>
                    </div>
                    <div class="layui-col-xs7 tool-bar-right">
                        <div id="formButtonGroup"></div>
                    </div>
                </div>
                <div id="reportForm" class="save-report-form">
                    <#list fields as field>
                    ${field.html}
                    </#list>
                </div>
            </form>
        </div>
    </div>
    <input type="hidden" id="processDefinitionId" value="${r'${processDefinitionId}'}">
    <input type="hidden" id="formCode" value="${r'${formCode}'}">
    <input type="hidden" id="formVersion" value="${r'${formVersion}'}">
</div>
<script src="static/form/js/form-util.js?v=1"></script>
<script src="static/form/js/oa-user-select.js?v=1"></script>
<script src="static/form/js/oa-form-util.js?v=1"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/',
        version: true
    }).extend({
        index: 'lib/index'
    }).use(['index', 'form', 'layer', 'laydate', 'laytpl', 'upload', 'restajax'], function () {
        var $ = layui.$;
        var form = layui.form;
        var layer = layui.layer;
        var laydate = layui.laydate;
        var restAjax = layui.restajax;
        var queryParams = restAjax.params(window.location.href);
        var token = queryParams.token;
        var formUtil = new FormUtil(layui, Viewer);
        var oaFormUtil = new OaFormUtil(layui);
        // 调试可先设置为空对象
        var confirmAssignees = ${r"${confirmAssignees}"};
        var fields = ${r"${fields}"};
        var formButton = ${r"${formButton}"};
        var currentUser = ${r"${currentUser}"};

        // 初始化
        function initData() {
            oaFormUtil.initSubmitBtns(confirmAssignees, {isApp: true});
            oaFormUtil.initFormButtons(formButton, {isApp:false, headers: {token: token}});

            <#list fields as field>
            <#if field.data.tag == 'uploadImage'>
            formUtil.initAppUploadImage('${field.data.id}', ${field.data.count}, {token: token});
            <#elseif field.data.tag == 'uploadFile'>
            formUtil.initAppUploadFile('${field.data.id}', ${field.data.count}, {token: token});
            <#elseif field.data.tag == 'uploadVideo'>
            formUtil.initAppUploadVideo('${field.data.id}', ${field.data.count}, {token: token});
                <#elseif field.data.tag == 'uploadAudio'>
            formUtil.initAppUploadAudio('${field.data.id}', ${field.data.count}, {token: token});
            <#elseif field.data.tag == 'date'>
            formUtil.initDate({
                id: '${field.data.id}',
                datetype: '${field.data.datetype}',
                dateformat: '${field.data.dateformat}',
                dateDefaultValue: '${field.data.dateDefaultValue}',
                dataMinValue: '${field.data.dataMinValue}',
                dataMaxValue: '${field.data.dataMaxValue}',
            });
            </#if>
            </#list>
            oaFormUtil.backFillFields(fields, currentUser);
            oaFormUtil.hideFields(fields);
            oaFormUtil.disableFields(fields);
        }
        initData();

        function close() {
            window.android.invokeNative('back');
        }

        // 关闭页面
        $('.close').on('click', function () {
            // 这里写返回按钮的逻辑，默认是关闭',
            close();
        });

        // 初始化按钮
        (function() {
            function confirmForm(formData) {
                layer.confirm('确定提交吗?', function(confirmLayerIndex) {
                    layer.close(confirmLayerIndex);

                    // 提交前处理
                    formUtil.clearUploadField(formData);
                    oaFormUtil.setEditHistoryFields(formData, fields);
                    oaFormUtil.setCcs(formData);

                    var loadLayerIndex;
                    restAjax.post(restAjax.path('app/oa-form-report/save/definition-id/{processDefinitionId}/code/{formCode}/version/{formVersion}', [
                        $('#processDefinitionId').val(),
                        $('#formCode').val(),
                        $('#formVersion').val(),
                    ]), formData.field, {
                        headers: {token: token}
                    }, function (code, data) {
                        // 这里手动添加操作成功后的操作',
                        layer.msg('提交成功', {time: 1000}, function() {
                            close();
                        });
                    }, function (code, data) {
                        $('.confirm-btn').show();
                        layer.msg(data.msg);
                    }, function () {
                        $('.confirm-btn').hide();
                        loadLayerIndex = layer.msg('提交中...', {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        layer.close(loadLayerIndex);
                    });
                });
            }

            for(var i = 0, item; item = confirmAssignees[i++];) {
                // 提交表单
                form.on('submit(submit'+ i +')', function (formData) {
                    var dataset = formData.elem.dataset;
                    var btnText = formData.elem.innerText;
                    var confirmMsg = '确定 '+ btnText +'?';
                    var index = dataset.index;
                    var isNextEndEvent = dataset.nextEndEvent;
                    var selectType = dataset.selectType === 'normal' ? 'radio' : 'checkbox';
                    var btnExc = dataset.btnExc ? dataset.btnExc : '';

                    formData.field.selectType = selectType;
                    formData.field.isNextEndEvent = isNextEndEvent;
                    formData.field.exc = btnExc;
                    // 代理人列表为空时，直接提交
                    if(confirmAssignees[index].assignees.length == 0) {
                        formData.field.assignees = [];
                        confirmForm(formData, confirmMsg);
                        return false;
                    }
                    if(confirmAssignees[index].assignees.length == 1) {
                        formData.field.assignees = [confirmAssignees[index].assignees[0].userId];
                        confirmForm(formData, confirmMsg);
                        return false;
                    }

                    formUtil.selectUsers({
                        selectType: selectType,
                        users: confirmAssignees[index].assignees,
                        selectedUserIds: [],
                        onConfirm: function(selectedUsers) {
                            if(!selectedUsers) {
                                return;
                            }
                            var assignees = [];
                            for(var j = 0, jItem; jItem = selectedUsers[j++];) {
                                assignees.push(jItem.userId);
                            }
                            formData.field.assignees = assignees;
                            confirmForm(formData, confirmMsg);
                        }
                    });
                    return false;
                });
            }
        })();
    });
</script>
</body>
</html>